/**
 * EN.java
 *
 * File generated from the datatypes::EN uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ips.datatypes;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlMixed;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.ips.datatypes.ObjectFactory;
import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class EN.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "EN", propOrder = {
	"mixed",
	"use"
})
@XmlRootElement(name = "EN")
public class EN extends net.ihe.gazelle.ips.datatypes.ANY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "delimiter", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "family", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "given", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "prefix", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "suffix", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "validTime", namespace = "urn:hl7-org:v3", type = JAXBElement.class)
		})
		@XmlMixed
	public List<java.io.Serializable> mixed;
	/**
	 *  A set of codes advising a system or user which name in a set of like names to select for a given purpose. A name without specific use code might be a default name useful for any purpose, but a name with a specific use code would be preferred for that respective purpose. .
	 */
	@XmlAttribute(name = "use")
	public List<String> use;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return mixed.
	 * @return mixed
	 */
	public List<java.io.Serializable> getMixed() {
		if (mixed == null) {
	        mixed = new ArrayList<java.io.Serializable>();
	    }
	    return mixed;
	}
	
	/**
	 * Set a value to attribute mixed.
	 * @param mixed.
	 */
	public void setMixed(List<java.io.Serializable> mixed) {
	    this.mixed = mixed;
	}
	
	
	
	/**
	 * Add a mixed to the mixed collection.
	 * @param mixed_elt Element to add.
	 */
	public void addMixed(java.io.Serializable mixed_elt) {
	    this.getMixed().add(mixed_elt);
	}
	
	/**
	 * Remove a mixed to the mixed collection.
	 * @param mixed_elt Element to remove
	 */
	public void removeMixed(java.io.Serializable mixed_elt) {
	    this.getMixed().remove(mixed_elt);
	}
	
	
	/**
	 * Return delimiter.
	 * @return delimiter
	 */
	public List<net.ihe.gazelle.ips.datatypes.EnDelimiter> getDelimiter() {
		List<net.ihe.gazelle.ips.datatypes.EnDelimiter> delimiter_el = new ArrayList<net.ihe.gazelle.ips.datatypes.EnDelimiter>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("delimiter")){
					delimiter_el.add( (net.ihe.gazelle.ips.datatypes.EnDelimiter) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return delimiter_el;
	}
	
	public void addDelimiter(net.ihe.gazelle.ips.datatypes.EnDelimiter obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.EnDelimiter> jobj = of.createENDelimiter(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return family.
	 * @return family
	 */
	public List<net.ihe.gazelle.ips.datatypes.EnFamily> getFamily() {
		List<net.ihe.gazelle.ips.datatypes.EnFamily> family_el = new ArrayList<net.ihe.gazelle.ips.datatypes.EnFamily>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("family")){
					family_el.add( (net.ihe.gazelle.ips.datatypes.EnFamily) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return family_el;
	}
	
	public void addFamily(net.ihe.gazelle.ips.datatypes.EnFamily obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.EnFamily> jobj = of.createENFamily(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return given.
	 * @return given
	 */
	public List<net.ihe.gazelle.ips.datatypes.EnGiven> getGiven() {
		List<net.ihe.gazelle.ips.datatypes.EnGiven> given_el = new ArrayList<net.ihe.gazelle.ips.datatypes.EnGiven>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("given")){
					given_el.add( (net.ihe.gazelle.ips.datatypes.EnGiven) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return given_el;
	}
	
	public void addGiven(net.ihe.gazelle.ips.datatypes.EnGiven obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.EnGiven> jobj = of.createENGiven(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return prefix.
	 * @return prefix
	 */
	public List<net.ihe.gazelle.ips.datatypes.EnPrefix> getPrefix() {
		List<net.ihe.gazelle.ips.datatypes.EnPrefix> prefix_el = new ArrayList<net.ihe.gazelle.ips.datatypes.EnPrefix>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("prefix")){
					prefix_el.add( (net.ihe.gazelle.ips.datatypes.EnPrefix) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return prefix_el;
	}
	
	public void addPrefix(net.ihe.gazelle.ips.datatypes.EnPrefix obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.EnPrefix> jobj = of.createENPrefix(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return suffix.
	 * @return suffix
	 */
	public List<net.ihe.gazelle.ips.datatypes.EnSuffix> getSuffix() {
		List<net.ihe.gazelle.ips.datatypes.EnSuffix> suffix_el = new ArrayList<net.ihe.gazelle.ips.datatypes.EnSuffix>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("suffix")){
					suffix_el.add( (net.ihe.gazelle.ips.datatypes.EnSuffix) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return suffix_el;
	}
	
	public void addSuffix(net.ihe.gazelle.ips.datatypes.EnSuffix obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.EnSuffix> jobj = of.createENSuffix(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return validTime.
	 * @return validTime
	 */
	public net.ihe.gazelle.ips.datatypes.IVLTS getValidTime() {
		net.ihe.gazelle.ips.datatypes.IVLTS validTime_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("validTime")){
					validTime_el = (net.ihe.gazelle.ips.datatypes.IVLTS) ((JAXBElement<?>)obj).getValue();
					return validTime_el;
				}
			}
		} 

	    return validTime_el;
	}
	
	public void addValidTime(net.ihe.gazelle.ips.datatypes.IVLTS obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.IVLTS> jobj = of.createENValidTime(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return use.
	 * @return use :  A set of codes advising a system or user which name in a set of like names to select for a given purpose. A name without specific use code might be a default name useful for any purpose, but a name with a specific use code would be preferred for that respective purpose. 
	 */
	public List<String> getUse() {
		if (use == null) {
	        use = new ArrayList<String>();
	    }
	    return use;
	}
	
	/**
	 * Set a value to attribute use.
	 * @param use :  A set of codes advising a system or user which name in a set of like names to select for a given purpose. A name without specific use code might be a default name useful for any purpose, but a name with a specific use code would be preferred for that respective purpose. .
	 */
	public void setUse(List<String> use) {
	    this.use = use;
	}
	
	
	
	/**
	 * Add a use to the use collection.
	 * @param use_elt Element to add.
	 */
	public void addUse(String use_elt) {
	    this.getUse().add(use_elt);
	}
	
	/**
	 * Remove a use to the use collection.
	 * @param use_elt Element to remove
	 */
	public void removeUse(String use_elt) {
	    this.getUse().remove(use_elt);
	}
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.ips.datatypes");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "EN").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	public List<String> getListStringValues(){
		List<String> res = new ArrayList<String>();
		for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof String){
				res.add((String)obj);
			}
		} 
		return res;
	}
	
		

	/**
	 * Description of the method cdaEquals.
	 *
	 * @param en1
	 * @return ret
	 */
	public Boolean cdaEquals(net.ihe.gazelle.ips.datatypes.EN en1) {
		Boolean ret = true;
		ret = ret && this.getFamily().equals(en1.getFamily());
		ret = ret && this.getGiven().equals(en1.getGiven());
		ret = ret && this.getPrefix().equals(en1.getPrefix());
		ret = ret && this.getSuffix().equals(en1.getSuffix());
		ret = ret && this.getUse().equals(en1.getUse());
		ret = ret && this.getListStringValues().equals(en1.getListStringValues());
		return ret;
	}
		

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(EN eN, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (eN != null){
   			net.ihe.gazelle.ips.datatypes.ANY.validateByModule(eN, _location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.EnDelimiter delimiter: eN.getDelimiter()){
					net.ihe.gazelle.ips.datatypes.EnDelimiter.validateByModule(delimiter, _location + "/delimiter[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.EnFamily family: eN.getFamily()){
					net.ihe.gazelle.ips.datatypes.EnFamily.validateByModule(family, _location + "/family[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.EnGiven given: eN.getGiven()){
					net.ihe.gazelle.ips.datatypes.EnGiven.validateByModule(given, _location + "/given[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.EnPrefix prefix: eN.getPrefix()){
					net.ihe.gazelle.ips.datatypes.EnPrefix.validateByModule(prefix, _location + "/prefix[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.EnSuffix suffix: eN.getSuffix()){
					net.ihe.gazelle.ips.datatypes.EnSuffix.validateByModule(suffix, _location + "/suffix[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.ips.datatypes.IVLTS.validateByModule(eN.getValidTime(), _location + "/validTime", cvm, diagnostic);
    	}
    }

}